/**  
 *  BookReporter - Generate usage reports from text files
 *  Copyright (C) 2011 Skye Book
 *  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.skyebook.bookreporter.export;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Map.Entry;

import net.skyebook.bookreporter.BookDictionary;

/**
 * @author Skye Book
 *
 */
public class OneWordPerLineExporter extends DictionaryFileExporter {

	/**
	 * @param file
	 */
	public OneWordPerLineExporter(File file) {
		super(file);
		// TODO Auto-generated constructor stub
	}

	/* (non-Javadoc)
	 * @see net.skyebook.bookreporter.export.DictionaryExporter#export(net.skyebook.bookreporter.BookDictionary)
	 */
	@Override
	public void export(BookDictionary dictionary) throws IOException{
			if(!file.exists()) file.createNewFile();
			PrintWriter writer = new PrintWriter(file);
			
			int buffer = 0;
			
			for(Entry<String, Integer> word : dictionary.entrySet()){
				buffer++;
				writer.write(word.getKey());
				writer.write("\t");
				writer.write(""+word.getValue());
				writer.write("\n");
				
				if(buffer>=100){
					writer.flush();
					buffer=0;
				}
			}
			
			
			// perform a final flush
			writer.flush();
	}
}
